import { Middleware } from './../../middleware';
import { TsHubLogger } from './../../../logging/ts-hub-logger';
import { Handler } from './handler';
import { MiddlewareBuilder } from './middleware-builder';
import { ControllerActivator } from "../../activator/controller-activator";
export declare abstract class ConstructorMiddlewareBuilder<Information, GenericRouter, RequestHandler> implements MiddlewareBuilder<Information, GenericRouter, RequestHandler> {
    protected activator: ControllerActivator<GenericRouter, RequestHandler>;
    protected tsHubLogger: TsHubLogger;
    protected information: Information;
    protected target: any;
    protected propertyKey: string;
    protected middlewareConstructor: new (...args: any[]) => Handler<Information>;
    protected priority: number;
    constructor(activator: ControllerActivator<GenericRouter, RequestHandler>, tsHubLogger: TsHubLogger);
    withInformation(information: Information): this;
    withTarget(target: any): this;
    withPropertyKey(propertyKey: string): this;
    withPriority(priority: number): this;
    withMiddlewareConstructor(middlewareConstructor: new (...args: any[]) => Handler<Information>): this;
    buildMiddleware(router: GenericRouter): Middleware<Information, RequestHandler>;
    abstract supportsRouter(router: GenericRouter): boolean;
}
