import { TsHubLogger } from './../logging/ts-hub-logger';
import { TsFramework } from './ts-framework';
import { Server, ServerConfigurator } from "./";
import { HubContainer } from "../";
import { Hub } from "./hub";
export declare class HubBuilder {
    protected supportedServers: {
        server: Server;
        serverConfigurator: ServerConfigurator<Server>;
    }[];
    protected tsFramework: TsFramework;
    protected container: HubContainer;
    protected logger: TsHubLogger;
    private static _instance;
    static readonly instance: HubBuilder;
    private constructor();
    withContainer(container: HubContainer): this;
    withLogger(logger: TsHubLogger): this;
    withFramework(tsFramework: TsFramework): this;
    withServerSupport<T extends Server>(server: T, serverConfigurator?: ServerConfigurator<T>): this;
    buildHub(): Hub;
    private initializeFramework();
    private initializeLogger();
    private initializeContainer();
}
